//+------------------------------------------------------------------+
//|                                                       Dan_EA.mq4 |
//|                                         Developed by Coders Guru |
//|                                            http://www.xpworx.com |
//+------------------------------------------------------------------+

#property copyright "DAN MOLDOVEANU"
#property link      "http://www.xpworx.com"
extern string   ver  = "Last Modified: 2009.08.04 18:45";


#define DO_BUY 1
#define DO_SELL -1
#define DO_BUY_EXIT 2
#define DO_SELL_EXIT -2
#define DO_NOTHING 0

/*
I have just ONE indicator changing colors (green for UP,red for DOWN). 
I wish EA open BUY position on OPEN PRICE of the SECOND CANDLE after the indicator turn GREEN and 
CLOSE position on the candle where indicator turn RED. After it close BUY position,on the 
next(open price)candle will open a SELL position,and so on. I guess it is called CLOSE AND 
REVERS. No TP .No SL(because,I guess,the broker will see the SL)
*/


extern      double      Lots                          = 0.1;
extern      double      TakeProfit                    = 250;        //Take profit level.
extern      double      StopLoss                      = 250;        //Stop loss level.
extern      bool        EmailNotification             = true;



//-----------------------------------------------
extern      int        TCCIAlert_Price                      = 0;
extern      int        TCCIAlert_Length                     = 16;
extern      int        TCCIAlert_Displace                   = 0;
extern      int        TCCIAlert_Filter                     = 0;
extern      int        TCCIAlert_Color                      = 1;
extern      int        TCCIAlert_ColorBarBack               = 1;
extern      double     TCCIAlert_Deviation                  = 0.0;
extern      bool       TCCIAlert_Colour_Changing_Alert      = false;
extern      bool       TCCIAlert_Colour_Changed_Alert       = true;

//--- Global variables
string   ExpertName           = "Dan_EA";
int      MagicNumber          = 1234567;
double   mPoint               = 0.0001;
//-------------------------------------------

int init()
{
   MagicNumber = GetMagicNumber(2244);
   
   if(Point==0.00001) mPoint=0.0001;
   else if(Point==0.001) mPoint=0.01;
   else mPoint = Point;      
   return(0);
}

int deinit()
{
   return(0);
}

int start()
{
   int Signal = CheckSignal();
   int Exit = CheckExit();
   
   bool BuyCondition = false , SellCondition = false , CloseBuyCondition = false , CloseSellCondition = false;
   
   if (Signal == DO_BUY)
   { 
      BuyCondition = true;
      CloseSellCondition = true;
   }
   
   if (Signal == DO_SELL) 
   { 
      SellCondition = true;
      CloseBuyCondition = true;
   }
   
   /*if (Exit == DO_BUY_EXIT)
   { 
      CloseBuyCondition = true;
   }
   
   if (Exit == DO_SELL_EXIT) 
   { 
      CloseSellCondition = true;
   }*/
   
   int total  = OrdersTotal();
   
   if(total < 1 || isNewSymbol(Symbol(),MagicNumber)) 
   {
     if(BuyCondition) //<-- BUY condition
     {
         OpenOrder(Symbol(),OP_BUY,Lots,5,StopLoss,TakeProfit,MagicNumber,ExpertName);
         if (EmailNotification && IsTesting()==false) SendMail (ExpertName+"_"+Symbol(),ExpertName+"_"+Symbol()+"_Buy");
     }
     
     if(SellCondition) //<-- SELL condition
     {
         OpenOrder(Symbol(),OP_SELL,Lots,5,StopLoss,TakeProfit,MagicNumber,ExpertName);
         if (EmailNotification && IsTesting()==false)    SendMail (ExpertName+"_"+Symbol(),ExpertName+"_"+Symbol()+"_Sell");
     }
   }
   
   for(int cnt=0;cnt<OrdersTotal();cnt++) 
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber()==MagicNumber && OrderSymbol()==Symbol())
      {
         if(OrderType()==OP_BUY && CloseBuyCondition)
         {
            CloseOrder(OrderTicket(),OP_BUY);
            if (EmailNotification && IsTesting()==false) SendMail (ExpertName+"_"+Symbol(),ExpertName+"_"+Symbol()+"_BuyClose");
         }
         if(OrderType()==OP_SELL && CloseSellCondition)
         {
            CloseOrder(OrderTicket(),OP_SELL);
            if (EmailNotification && IsTesting()==false) SendMail (ExpertName+"_"+Symbol(),ExpertName+"_"+Symbol()+"_SellClose");
         }        
      }
   }
   
   return(0);
}

int CheckSignal()
{
   int TradeBar = 1;
   
   double buf_1_current = iCustom(NULL,0,"TCCIAlert",TCCIAlert_Price,TCCIAlert_Length,TCCIAlert_Displace,
   TCCIAlert_Filter,TCCIAlert_Color,TCCIAlert_ColorBarBack,TCCIAlert_Deviation,TCCIAlert_Colour_Changing_Alert,
   TCCIAlert_Colour_Changed_Alert,0,TradeBar);
   
   double buf_1_previous = iCustom(NULL,0,"TCCIAlert",TCCIAlert_Price,TCCIAlert_Length,TCCIAlert_Displace,
   TCCIAlert_Filter,TCCIAlert_Color,TCCIAlert_ColorBarBack,TCCIAlert_Deviation,TCCIAlert_Colour_Changing_Alert,
   TCCIAlert_Colour_Changed_Alert,0,TradeBar+1);

   double buf_2_current = iCustom(NULL,0,"TCCIAlert",TCCIAlert_Price,TCCIAlert_Length,TCCIAlert_Displace,
   TCCIAlert_Filter,TCCIAlert_Color,TCCIAlert_ColorBarBack,TCCIAlert_Deviation,TCCIAlert_Colour_Changing_Alert,
   TCCIAlert_Colour_Changed_Alert,1,TradeBar);

   double buf_2_previous = iCustom(NULL,0,"TCCIAlert",TCCIAlert_Price,TCCIAlert_Length,TCCIAlert_Displace,
   TCCIAlert_Filter,TCCIAlert_Color,TCCIAlert_ColorBarBack,TCCIAlert_Deviation,TCCIAlert_Colour_Changing_Alert,
   TCCIAlert_Colour_Changed_Alert,1,TradeBar+1);
   
   double buf_3_current = iCustom(NULL,0,"TCCIAlert",TCCIAlert_Price,TCCIAlert_Length,TCCIAlert_Displace,
   TCCIAlert_Filter,TCCIAlert_Color,TCCIAlert_ColorBarBack,TCCIAlert_Deviation,TCCIAlert_Colour_Changing_Alert,
   TCCIAlert_Colour_Changed_Alert,2,TradeBar);

   double buf_3_previous = iCustom(NULL,0,"TCCIAlert",TCCIAlert_Price,TCCIAlert_Length,TCCIAlert_Displace,
   TCCIAlert_Filter,TCCIAlert_Color,TCCIAlert_ColorBarBack,TCCIAlert_Deviation,TCCIAlert_Colour_Changing_Alert,
   TCCIAlert_Colour_Changed_Alert,2,TradeBar+1);
   
   if(buf_1_previous!=EMPTY_VALUE && buf_2_previous!=EMPTY_VALUE && buf_3_previous!=EMPTY_VALUE
   && buf_1_current != EMPTY_VALUE && buf_2_current == EMPTY_VALUE && buf_3_current != EMPTY_VALUE)
   {
      Print("Converted to Red");
      return(DO_SELL);
   }
   
   if(buf_1_previous!=EMPTY_VALUE && buf_2_previous!=EMPTY_VALUE && buf_3_previous!=EMPTY_VALUE
   && buf_1_current != EMPTY_VALUE && buf_2_current != EMPTY_VALUE && buf_3_current == EMPTY_VALUE)
   {
      Print("Converted to Green");
      return(DO_BUY);
   }
   
   Comment(buf_1_current,":",buf_1_previous,"\n",buf_2_current,":",buf_2_previous,"\n",buf_3_current,":",buf_3_previous);
   
   return(DO_NOTHING); //else   
}

int CheckExit()
{
   int TradeBar = 0;
   
   double buf_1_current = iCustom(NULL,0,"TCCIAlert",TCCIAlert_Price,TCCIAlert_Length,TCCIAlert_Displace,
   TCCIAlert_Filter,  TCCIAlert_Color,TCCIAlert_ColorBarBack,TCCIAlert_Deviation,TCCIAlert_Colour_Changing_Alert,
   TCCIAlert_Colour_Changed_Alert,0,TradeBar);
   
   double buf_1_previous = iCustom(NULL,0,"TCCIAlert",TCCIAlert_Price,TCCIAlert_Length,TCCIAlert_Displace,
   TCCIAlert_Filter,  TCCIAlert_Color,TCCIAlert_ColorBarBack,TCCIAlert_Deviation,TCCIAlert_Colour_Changing_Alert,
   TCCIAlert_Colour_Changed_Alert,0,TradeBar+1);

   double buf_2_current = iCustom(NULL,0,"TCCIAlert",TCCIAlert_Price,TCCIAlert_Length,TCCIAlert_Displace,
   TCCIAlert_Filter,  TCCIAlert_Color,TCCIAlert_ColorBarBack,TCCIAlert_Deviation,TCCIAlert_Colour_Changing_Alert,
   TCCIAlert_Colour_Changed_Alert,1,TradeBar);

   double buf_2_previous = iCustom(NULL,0,"TCCIAlert",TCCIAlert_Price,TCCIAlert_Length,TCCIAlert_Displace,
   TCCIAlert_Filter,  TCCIAlert_Color,TCCIAlert_ColorBarBack,TCCIAlert_Deviation,TCCIAlert_Colour_Changing_Alert,
   TCCIAlert_Colour_Changed_Alert,1,TradeBar+1);
   
   double buf_3_current = iCustom(NULL,0,"TCCIAlert",TCCIAlert_Price,TCCIAlert_Length,TCCIAlert_Displace,
   TCCIAlert_Filter,  TCCIAlert_Color,TCCIAlert_ColorBarBack,TCCIAlert_Deviation,TCCIAlert_Colour_Changing_Alert,
   TCCIAlert_Colour_Changed_Alert,2,TradeBar);

   double buf_3_previous = iCustom(NULL,0,"TCCIAlert",TCCIAlert_Price,TCCIAlert_Length,TCCIAlert_Displace,
   TCCIAlert_Filter,  TCCIAlert_Color,TCCIAlert_ColorBarBack,TCCIAlert_Deviation,TCCIAlert_Colour_Changing_Alert,
   TCCIAlert_Colour_Changed_Alert,2,TradeBar+1);
   
   if(buf_1_previous!=EMPTY_VALUE && buf_2_previous!=EMPTY_VALUE && buf_3_previous!=EMPTY_VALUE
   && buf_1_current != EMPTY_VALUE && buf_2_current == EMPTY_VALUE && buf_3_current != EMPTY_VALUE)
   {
      return(DO_BUY_EXIT);
   }
   
   if(buf_1_previous!=EMPTY_VALUE && buf_2_previous!=EMPTY_VALUE && buf_3_previous!=EMPTY_VALUE
   && buf_1_current != EMPTY_VALUE && buf_2_current != EMPTY_VALUE && buf_3_current == EMPTY_VALUE)
   {
      return(DO_SELL_EXIT);
   }
   
   
   return(DO_NOTHING); //else   
}

int GetMagicNumber(int base)
{
   int Reference = 0;
   if (StringFind(StringUpperCase(Symbol()),"AUDCAD")>-1) Reference = base + 1001;
   if (StringFind(StringUpperCase(Symbol()),"AUDJPY")>-1) Reference = base + 2002;
   if (StringFind(StringUpperCase(Symbol()),"AUDNZD")>-1) Reference = base + 3003;
   if (StringFind(StringUpperCase(Symbol()),"AUDUSD")>-1) Reference = base + 4004;
   if (StringFind(StringUpperCase(Symbol()),"CHFJPY")>-1) Reference = base + 5005;
   if (StringFind(StringUpperCase(Symbol()),"EURAUD")>-1) Reference = base + 6006;
   if (StringFind(StringUpperCase(Symbol()),"EURCAD")>-1) Reference = base + 7007;
   if (StringFind(StringUpperCase(Symbol()),"EURCHF")>-1) Reference = base + 8008;
   if (StringFind(StringUpperCase(Symbol()),"EURGBP")>-1) Reference = base + 9009;
   if (StringFind(StringUpperCase(Symbol()),"EURJPY")>-1) Reference = base + 10010;
   if (StringFind(StringUpperCase(Symbol()),"EURUSD")>-1) Reference = base + 11011;
   if (StringFind(StringUpperCase(Symbol()),"GBPCHF")>-1) Reference = base + 12012;
   if (StringFind(StringUpperCase(Symbol()),"GBPJPY")>-1) Reference = base + 13013;
   if (StringFind(StringUpperCase(Symbol()),"GBPUSD")>-1) Reference = base + 14014;
   if (StringFind(StringUpperCase(Symbol()),"NZDJPY")>-1) Reference = base + 15015;
   if (StringFind(StringUpperCase(Symbol()),"NZDUSD")>-1) Reference = base + 16016;
   if (StringFind(StringUpperCase(Symbol()),"USDCHF")>-1) Reference = base + 17017;
   if (StringFind(StringUpperCase(Symbol()),"USDJPY")>-1) Reference = base + 18018;
   if (StringFind(StringUpperCase(Symbol()),"USDCAD")>-1) Reference = base + 19019;
   if (Reference == 0) Reference = base + 1999;
   return(Reference);
}

bool CloseOrder(int tick, int type)
{
   OrderSelect(tick,SELECT_BY_TICKET,MODE_TRADES);
   if(OrderMagicNumber() == MagicNumber)
   {
      if(type==OP_BUY)
         return (OrderClose(OrderTicket(),OrderLots(),Bid,5,Violet));
      if(type==OP_SELL)   
         return (OrderClose(OrderTicket(),OrderLots(),Ask,5,Violet));
   }
}


bool isNewSymbol(string current_symbol, int magic)
{
   int total  = OrdersTotal();
   for(int cnt = 0 ; cnt < total ; cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      string selected_symbol = OrderSymbol();
      if (current_symbol == selected_symbol && OrderMagicNumber()== magic)
      return (False);
    }
    return (True);
}

int OpenOrder(string TradeSymbol, int TradeType, double TradeLot, int TradeSlippage, int TradeStopLoss, int TradeTakeProfit, int TradeMagic, string TradeComment = "", int TriesCount = 5)
{
   int ticket=0;
   int err=0;
   int num = 0;
   
   if(TradeType == OP_BUY)
   {
      for(num = 0 ; num < TriesCount ; num++)
      {
         if(TradeStopLoss>0 && TradeTakeProfit>0)
            ticket=OrderSend(TradeSymbol,OP_BUY,TradeLot,Ask,TradeSlippage,Ask-TradeStopLoss*mPoint,Ask+TradeTakeProfit*mPoint,TradeComment,TradeMagic,0,Green);
         if(TradeStopLoss==0 && TradeTakeProfit==0)
            ticket=OrderSend(TradeSymbol,OP_BUY,TradeLot,Ask,TradeSlippage,0,0,TradeComment,TradeMagic,0,Green);
         if(TradeStopLoss>0 && TradeTakeProfit==0)
            ticket=OrderSend(TradeSymbol,OP_BUY,TradeLot,Ask,TradeSlippage,Ask-TradeStopLoss*mPoint,0,TradeComment,TradeMagic,0,Green);
         if(TradeStopLoss==0 && TradeTakeProfit>0)
            ticket=OrderSend(TradeSymbol,OP_BUY,TradeLot,Ask,TradeSlippage,0,Ask+TradeTakeProfit*mPoint,TradeComment,TradeMagic,0,Green);
         
         err=GetLastError();
         if(err==4 || err==6 || err==8 || err==128 || err==129 || err==135 || err==136 || err==137 || err==138 || err==141 || err==146)
         { 
            Sleep(5000);
            continue;
         }
         else
         {
            break;
         }
      }   
   }
   
   if(TradeType == OP_SELL)
   {   
      for(num = 0 ; num < TriesCount ; num++)
      {
         if(TradeStopLoss>0 && TradeTakeProfit>0)
            ticket=OrderSend(TradeSymbol,OP_SELL,TradeLot,Bid,TradeSlippage,Bid+TradeStopLoss*mPoint,Bid-TradeTakeProfit*mPoint,TradeComment,TradeMagic,0,Red);
         if(TradeStopLoss==0 && TradeTakeProfit==0)
            ticket=OrderSend(TradeSymbol,OP_SELL,TradeLot,Bid,TradeSlippage,0,0,TradeComment,TradeMagic,0,Red);
         if(TradeStopLoss>0 && TradeTakeProfit==0)
            ticket=OrderSend(TradeSymbol,OP_SELL,TradeLot,Bid,TradeSlippage,Bid+TradeStopLoss*mPoint,0,TradeComment,TradeMagic,0,Red);
         if(TradeStopLoss==0 && TradeTakeProfit>0)
            ticket=OrderSend(TradeSymbol,OP_SELL,TradeLot,Bid,TradeSlippage,0,Bid-TradeTakeProfit*mPoint,TradeComment,TradeMagic,0,Red);

         err=GetLastError();
         if(err==4 || err==6 || err==8 || err==128 || err==129 || err==135 || err==136 || err==137 || err==138 || err==141 || err==146)
         { 
            Sleep(5000);
            continue;
         }
         else
         {
            break;
         }
      }   
   }  
   return(ticket);
}

string StringUpperCase(string str)
{
   int s = StringLen(str);
   int chr = 0;
   string temp;
   for (int c = 0 ; c < s ; c++)
   {
      chr = StringGetChar(str,c);
      if (chr >= 97 && chr <=122) chr = chr - 32;
      temp = temp + CharToStr(chr);
   }
   return (temp);  
}

/*void DrawVerticalLine(string why , int bar , color clr)
{
   static int count = 0;
   count++;
   string Obj = "V_" + why + "_"+ DoubleToStr(count,0);
   ObjectCreate(Obj,OBJ_VLINE,0,Time[bar],0);
   ObjectSet(Obj,OBJPROP_COLOR,clr);
   ObjectSet(Obj,OBJPROP_WIDTH,2);
   ObjectsRedraw();
}*/



